/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.lib.basic.mappers.TextGlyphs;

import java.util.Arrays;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.visnow.jscic.Field;
import org.visnow.jscic.RegularField;
import org.visnow.jscic.dataarrays.DataArray;
import org.visnow.jscic.dataarrays.DataArrayType;
import static org.visnow.jscic.dataarrays.DataArrayType.*;
import org.visnow.vn.geometries.parameters.DataMappingParams;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 */
public class GUI extends javax.swing.JPanel
{

    private Params params = new Params();
    private Field inField = null;
    private String floatFormat = "%4.1f", intFormat = "%3d";
    private String format = floatFormat;

    /**
     * Creates new form VNgraph3DUI
     */
    public GUI()
    {
        initComponents();
        postInitComponents();

    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup1 = new javax.swing.ButtonGroup();
        mapComboBox = new org.visnow.vn.lib.gui.DataComponentSelector();
        downsizeUI = new org.visnow.vn.lib.gui.FieldBasedUI.DownsizeUI.DownsizeUI();
        cropUI = new org.visnow.vn.lib.gui.cropUI.CropUI();
        formatLabel = new javax.swing.JLabel();
        formatField = new javax.swing.JTextField();
        fontGUI = new org.visnow.vn.geometries.gui.FontGUI();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 32767));
        jPanel1 = new javax.swing.JPanel();
        thresholdUI = new org.visnow.vn.lib.gui.ComponentBasedUI.range.ComponentSubrangeUI();
        insideButton = new javax.swing.JRadioButton();
        outsideButton = new javax.swing.JRadioButton();

        setLayout(new java.awt.GridBagLayout());

        mapComboBox.setBorder(javax.swing.BorderFactory.createTitledBorder("data component"));
        mapComboBox.setMinimumSize(new java.awt.Dimension(150, 50));
        mapComboBox.setNumericComponentsOnly(false);
        mapComboBox.setPreferredSize(new java.awt.Dimension(200, 55));
        mapComboBox.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                mapComboBoxStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(mapComboBox, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(downsizeUI, gridBagConstraints);

        cropUI.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));
        cropUI.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                cropUIStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(cropUI, gridBagConstraints);

        formatLabel.setFont(new java.awt.Font("Dialog", 0, 14)); // NOI18N
        formatLabel.setText("number format");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 9, 0, 0);
        add(formatLabel, gridBagConstraints);

        formatField.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                formatFieldActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 3);
        add(formatField, gridBagConstraints);

        fontGUI.setBorder(javax.swing.BorderFactory.createTitledBorder("glyph font and decoration"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(11, 0, 11, 0);
        add(fontGUI, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.0;
        add(filler1, gridBagConstraints);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "show text when", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 1, 14))); // NOI18N
        jPanel1.setLayout(new java.awt.GridBagLayout());

        thresholdUI.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanel1.add(thresholdUI, gridBagConstraints);

        buttonGroup1.add(insideButton);
        insideButton.setFont(new java.awt.Font("Dialog", 1, 14)); // NOI18N
        insideButton.setSelected(true);
        insideButton.setText("inside range");
        insideButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                insideButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        jPanel1.add(insideButton, gridBagConstraints);

        buttonGroup1.add(outsideButton);
        outsideButton.setFont(new java.awt.Font("Dialog", 1, 14)); // NOI18N
        outsideButton.setText("outside range");
        outsideButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                outsideButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        jPanel1.add(outsideButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jPanel1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    /**
     * Additional initialization of components that can't be made from NetBeans GUI including:
     * set text format to default
     */
    private void postInitComponents()
    {
        //TODO: call updateUI from or other method dedicated to update UI (like after loading network from vna)
        formatField.setText(params.getFormat());
        mapComboBox.setTitle("glyph size component");
    }

    private void updateUI(DataArray da)
    {
        DataArrayType daType = da.getType();
        formatLabel.setEnabled(da.isNumeric());
        formatField.setEnabled(da.isNumeric());
        if ((daType == FIELD_DATA_BYTE || daType == DataArrayType.FIELD_DATA_SHORT ||
             daType == FIELD_DATA_INT  || daType == DataArrayType.FIELD_DATA_LONG) &&
            !format.endsWith("d")) 
            format = intFormat;
        if ((daType == FIELD_DATA_FLOAT || daType == DataArrayType.FIELD_DATA_DOUBLE ||
             daType == FIELD_DATA_COMPLEX) &&
            !(format.endsWith("e") || format.endsWith("f"))) 
            format = floatFormat;
        formatField.setText(format);
        params.setFormat(format);
    }
    
    private void mapComboBoxStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_mapComboBoxStateChanged
    {//GEN-HEADEREND:event_mapComboBoxStateChanged
        params.setActive(false);
        String s = mapComboBox.getComponentName();
        params.setComponent(s);
        DataArray da = inField.getComponent(s);
        if (da != null)
            updateUI(da);
        params.setActive(true);
    }//GEN-LAST:event_mapComboBoxStateChanged

    private void formatFieldActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_formatFieldActionPerformed
    {//GEN-HEADEREND:event_formatFieldActionPerformed
        String fmt = formatField.getText();
        if (fmt.matches("%d") || fmt.matches("%f") || fmt.matches("%e") || 
            fmt.matches("%1?\\dd") || fmt.matches("%1?\\d\\.\\d[ef]"))
            format = fmt;
        params.setFormat(format);
    }//GEN-LAST:event_formatFieldActionPerformed

    private void cropUIStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_cropUIStateChanged
    {//GEN-HEADEREND:event_cropUIStateChanged
        if(!cropUI. isAdjusting()) {
            params.setCrop(cropUI.getLow(), cropUI.getUp());
        }
    }//GEN-LAST:event_cropUIStateChanged

    private void insideButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_insideButtonActionPerformed
    {//GEN-HEADEREND:event_insideButtonActionPerformed
        params.setInsideRange(insideButton.isSelected());
    }//GEN-LAST:event_insideButtonActionPerformed

    private void outsideButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_outsideButtonActionPerformed
    {//GEN-HEADEREND:event_outsideButtonActionPerformed
        params.setInsideRange(!outsideButton.isSelected());
    }//GEN-LAST:event_outsideButtonActionPerformed

    public void setInData(Field newInField, DataMappingParams mapParams)
    {
        if (newInField == null)
            return;
        params.setActive(false);
        inField = newInField;
        mapComboBox.setDataSchema(inField.getSchema());
        String s = mapComboBox.getComponentName();
        params.setComponent(s);
        DataArray da = inField.getComponent(s);
        if (da != null)
            updateUI(da);
        if (newInField instanceof RegularField) {
            int[] dims = ((RegularField)newInField).getDims();
            int[] low = new int[dims.length];
            Arrays.fill(low, 0);
            int[] up = Arrays.copyOf(dims, dims.length);
            cropUI.setNewExtents(dims, low, up, true);
            params.setCrop(low, up);
        }
        cropUI.setVisible(newInField instanceof RegularField && !params.getDownsizeParams().isRandom());
        params.setActive(true);
    }

    public void setParams(Params params)
    {
        this.params = params;
        fontGUI.setParams(params.getFontParams());
        downsizeUI.setParams(params.getDownsizeParams());
        thresholdUI.setComponentValue(params.getValidComponentRange());
        params.getDownsizeParams().addChangeListener(new ChangeListener(){
            @Override
            public void stateChanged(ChangeEvent e) {
                cropUI.setVisible(inField instanceof RegularField && !params.getDownsizeParams().isRandom());
            }
        
        });
    }

    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private org.visnow.vn.lib.gui.cropUI.CropUI cropUI;
    private org.visnow.vn.lib.gui.FieldBasedUI.DownsizeUI.DownsizeUI downsizeUI;
    private javax.swing.Box.Filler filler1;
    private org.visnow.vn.geometries.gui.FontGUI fontGUI;
    private javax.swing.JTextField formatField;
    private javax.swing.JLabel formatLabel;
    private javax.swing.JRadioButton insideButton;
    private javax.swing.JPanel jPanel1;
    private org.visnow.vn.lib.gui.DataComponentSelector mapComboBox;
    private javax.swing.JRadioButton outsideButton;
    private org.visnow.vn.lib.gui.ComponentBasedUI.range.ComponentSubrangeUI thresholdUI;
    // End of variables declaration//GEN-END:variables
}
